package javax.management.loading;

import java.util.Iterator;
import javax.management.MBeanServer;
import javax.management.MBeanServerFactory;
import java.util.logging.Level;
import com.sun.jmx.defaults.JmxProperties;

@Deprecated
public class DefaultLoaderRepository
{
    public DefaultLoaderRepository() {
    }
    
    public static Class<?> loadClass(String msg) throws ClassNotFoundException {
        JmxProperties.MBEANSERVER_LOGGER.logp(Level.FINEST, DefaultLoaderRepository.class.getName(), "loadClass", msg);
        return load(null, msg);
    }
    
    public static Class<?> loadClassWithout(ClassLoader classLoader, String msg) throws ClassNotFoundException {
        JmxProperties.MBEANSERVER_LOGGER.logp(Level.FINEST, DefaultLoaderRepository.class.getName(), "loadClassWithout", msg);
        return load(classLoader, msg);
    }
    
    private static Class<?> load(ClassLoader classLoader, String s) throws ClassNotFoundException {
        Iterator<Object> iterator = MBeanServerFactory.findMBeanServer(null).iterator();
        while (iterator.hasNext()) {
            ClassLoaderRepository classLoaderRepository = ((MBeanServer)iterator.next()).getClassLoaderRepository();
            try {
                return classLoaderRepository.loadClassWithout(classLoader, s);
            }
            catch (ClassNotFoundException ex) {}
        }
        throw new ClassNotFoundException(s);
    }
}
